#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	ofBackground(86, 177, 239);
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	redemoinho.loadImage("whirlpool.png");
	
	
	for (int i = 0; i < 50; i++){
		particle myParticle;
		myParticle.setInitialCondition(-600,ofRandom(200, ofGetHeight()-200),i,0);
		particles.push_back(myParticle);
	}
	
	VF.setupField(60,40,ofGetWidth(), ofGetHeight());
	//VF.randomizeField(1.0);
	
	/*
	//create vectors of force
	VF.addClockwiseCircle(200, 400, 100, 0.7f);
	VF.addInwardCircle(200, 400, 200, 0.7f);
*/
	

	/*
	VF.addClockwiseCircle(600, 400, 100, 0.7f);
	VF.addInwardCircle(600, 400, 200, 0.7f);
	*/
	/*
	for (int i=0; i<4; i++) {
		ofPoint temp;
		temp.x=ofRandom(0,ofGetWidth());
		temp.y= ofRandom(0,ofGetHeight());
		redemoinhos.push_back(temp); 

	}*/
	
	
	
	/*
	VF.addClockwiseCircle(ofRandom(0,ofGetWidth()), ofRandom(0,ofGetHeight()), 200, 0.6f);
	VF.addInwardCircle(ofRandom(0,ofGetWidth()), ofRandom(0,ofGetHeight()), 200, 0.3f);
	
	VF.addClockwiseCircle(ofRandom(0,ofGetWidth()), ofRandom(0,ofGetHeight()), 200, 0.6f);
	VF.addInwardCircle(ofRandom(0,ofGetWidth()), ofRandom(0,ofGetHeight()), 200, 0.3f);
	 */
	
	drawingStyle = 0;
	bFade = false;
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	/*
	for (int i=0; i<redemoinhos.size();i++){
		VF.addClockwiseCircle(redemoinhos[i].x, redemoinhos[i].y, 200, 0.6f);
		VF.addInwardCircle(redemoinhos[i].x, redemoinhos[i].y, 200, 0.3f);
	}
	*/
	
	for (int i = 0; i < particles.size(); i++){
		
		particles[i].resetForce();
		
		// get the force from the vector field: 
		ofxVec2f frc;
		frc = VF.getForceFromPos(particles[i].pos.x, particles[i].pos.y);
		particles[i].addForce(frc.x, frc.y);
	
		
		//Add forces accordingly to keys

			switch (keyForce){
				case 0: particles[i].addForce(0, 0);;
					break;
				case 1: particles[i].addForce(0, -0.03);;
					break;
				case 2: particles[i].addForce(0, 0.03);;
					break;
				case 3: particles[i].addForce(0.03, 0);;
					break;
				case 4: particles[i].addForce(-0.03, 0);;
					break;
			}		
						

		
		//horizontal force always happening
		particles[i].addForce(0.03, 0.04*cos(ofGetElapsedTimef()));

		
		
		particles[i].addDampingForce();
		particles[i].update();
		if (bFade == true) VF.fadeField(0.99f);

	}
}
	
	

//--------------------------------------------------------------
void testApp::draw(){
	
	ofSetColor(0,130,130, 200);
	//VF.draw();
	
	ofEnableAlphaBlending();
	ofSetColor(255,255,255,255);

	for (int i=0; i<redemoinhos.size();i++){
		redemoinho.draw(redemoinhos[i].x-120, redemoinhos[i].y-150,200,200);
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}
	ofDisableAlphaBlending();
/*
	ofSetColor(0,130,130, 200);
	ofRect(30,30,300,75);
	ofSetColor(255,255,255, 230);
	ofDrawBitmapString("space to clear\nchange drawing mode 'a'\ntoggle fade 'f'", 50, 50);
	
	
	
	ofSetColor(255,255,130, 230);
	
	
	
	switch (drawingStyle){
		case 0: ofDrawBitmapString("drawing mode: inward", 50, 90);
			break;
		case 1: ofDrawBitmapString("drawing mode: outward", 50, 90);
			break;
		case 2: ofDrawBitmapString("drawing mode: clockwise", 50, 90);
			break;
		case 3: ofDrawBitmapString("drawing mode: counter-clockwise", 50, 90); 
			break;
	}	*/
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	if (key == ' '){
		VF.clear();
	} else if (key == 'a'){
		drawingStyle ++;
		drawingStyle %= 4;
	} else if (key == 'f'){
		bFade = !bFade;
	} 
	
	
	else if (key == OF_KEY_UP){
		keyForce=1;
	} 	else if (key == OF_KEY_DOWN){
		keyForce=2;
	}	else if (key == OF_KEY_RIGHT){
		keyForce=3;
	}	else if (key == OF_KEY_LEFT){
		keyForce=4;
	}
	
	
	
	

}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	/*if (button == 0) {
		switch (drawingStyle){
			case 0: VF.addInwardCircle((float)x, (float)y, 200, 0.3f);
				break;
			case 1: VF.addOutwardCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 2: VF.addClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
			case 3: VF.addCounterClockwiseCircle((float)x, (float)y, 100, 0.3f);
				break;
		}		
	} else {
		
		particles.erase(particles.begin());
		particle myParticle;
		myParticle.setInitialCondition(x,y,0,0);
		particles.push_back(myParticle);
		
		
	}*/
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	ofPoint temp;
	temp.x=x;
	temp.y= y;
	redemoinhos.push_back(temp); 
	VF.addClockwiseCircle(x,y, 200, 0.6f);
	VF.addInwardCircle(x, y, 200, 0.3f);

}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
